#include "timer.h"
#include "usart.h"
#include "pid.h"
#include "mpu6050.h"
//#include "motor.h"

int NUM=0;

void TIM3_IRQHandler(void)
{ 			
 	if(TIM_GetITStatus(TIM3, TIM_IT_Update) == SET)
	{
	/*	TIM_ClearITPendingBit(TIM3, TIM_FLAG_Update);
		TIM_ClearFlag(TIM3, TIM_FLAG_Update);		
		if(TIM_GetCounter(TIM3)==4*500-1)
		{
			NUM--;
		}
		if(TIM_GetCounter(TIM3)==0)
		{
			NUM++;
		}*/
		Angle_Calculate();		
		Kalman_Filter(Angle_ax,Gyro_y);
		//Average();
		Psn_Calcu();	
		PWM_Calcu();
	}
	TIM_ClearITPendingBit(TIM3,TIM_IT_Update);  //жϱ־λ
}





void TIM3_Configuration(u16 arr,u16 psc) 
{ 			
/*	GPIO_InitTypeDef GPIO_InitStructure;
	TIM_ICInitTypeDef	TIM_ICInitStructure;
	TIM_TimeBaseInitTypeDef TIM_BaseInitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);	*/

	/*ʱòҪAFIO ֻҪΪùܼ*/							 
	/*GPIO_PinAFConfig(GPIOC,GPIO_PinSource6,GPIO_AF_TIM3);	//
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource7, GPIO_AF_TIM3);
															  
	GPIO_InitStructure.GPIO_Pin=GPIO_Pin_6|GPIO_Pin_7; //óʼGPIOΪPIN9
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;//GPIOٶΪ50MHz
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF;//GPIOģʽΪģʽ
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//GPIOΪ
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; //GPIOΪ
	GPIO_Init(GPIOC,&GPIO_InitStructure);
	
	
	TIM_BaseInitStructure.TIM_Period = 1000-1; 					//תһȦжһ
	TIM_BaseInitStructure.TIM_Prescaler = 0;   				//ʱԤƵ
	TIM_BaseInitStructure.TIM_ClockDivision = 0;   			//ʱӷָ
	TIM_BaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;	 //ϼģʽ
	TIM_TimeBaseInit(TIM3, &TIM_BaseInitStructure);	
	
	TIM_ARRPreloadConfig(TIM3,ENABLE); 
	TIM_EncoderInterfaceConfig(TIM3, TIM_EncoderMode_TI12, TIM_ICPolarity_Rising, TIM_ICPolarity_Rising); 
	TIM_ICStructInit(&TIM_ICInitStructure);
	TIM_ICInitStructure.TIM_ICFilter=6;
	
	TIM_ICInit(TIM3,&TIM_ICInitStructure);
	TIM_ClearFlag(TIM3, TIM_FLAG_Update); 
	TIM_ITConfig(TIM3, TIM_IT_Update, ENABLE);
	TIM_Cmd(TIM3, ENABLE);		*/
	
	
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,ENABLE);  ///ʹTIM3ʱ
	
  TIM_TimeBaseInitStructure.TIM_Period = arr; 	//Զװֵ
	TIM_TimeBaseInitStructure.TIM_Prescaler=psc;  //ʱƵ
	TIM_TimeBaseInitStructure.TIM_CounterMode=TIM_CounterMode_Up; //ϼģʽ
	TIM_TimeBaseInitStructure.TIM_ClockDivision=TIM_CKD_DIV1; 
	
	TIM_TimeBaseInit(TIM3,&TIM_TimeBaseInitStructure);//ʼTIM3
	
	TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE); //ʱ3ж
	TIM_Cmd(TIM3,ENABLE); //ʹܶʱ3
	
	NVIC_InitStructure.NVIC_IRQChannel=TIM3_IRQn; //ʱ3ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=0x02; //ռȼ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority=0x03; //ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}  

/*
void NVIC_Configuration(void)
{   	
  NVIC_InitTypeDef	NVIC_InitStructure;
 	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ȼѡ


	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;			 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1; 
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;	 
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; 		 
	NVIC_Init(&NVIC_InitStructure);				  

 }
*/
